<!------------------------------------------------------------------------------
cf_advancedemail
Used in conjunction with cf_advancedemailparam to send multipart/related and
multipart/alternative emails.

Copyright (c) 2000-2002, Jochem van Dieten e.a.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, 
	  this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, 
	  this list of conditions and the following disclaimer in the documentation 
	  and/or other materials provided with the distribution.
    * Neither the name of the author nor the names of its contributors 
	  may be used to endorse or promote products derived from this software 
	  without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------->
<cfif not thistag.HasEndTag>
	<cfthrow message="CF_advancedemail requires an end tag">
</cfif>

<cftry>
<cfsilent>
<cfif ThisTag.ExecutionMode IS 'start'>
	<cfparam name="attributes.inline" default=TRUE>
	<cfparam name="attributes.cache" default=TRUE>
	<cfparam name="attributes.cfversion" default="4.5.0">
	<cfparam name="attributes.mode" default="silent">
	<cfparam name="attributes.type" default="Alternative">
	<cfparam name="attributes.timezoneoverride" default="0000">
	<cfparam name="attributes.format" default="CF">
	<cfparam name="attributes.Exclude" default="cfm,cfml,dbm,jsp,cgi,pl,exe,dll,js">

	<!--- initialize parameters --->
	<cfscript>
	// Create structure for all persistent data for this tag.
	// Used to move data from the starttag and the <cf_advancedemailparam> tags
	// to the closing <cf_advancedemail> tag
	// Note: this should be rewritten to use <cfassociate>
	// If the structure exists it might have cached info so don't overwrite
	if (NOT IsDefined("request.AdvancedEmail"))
		request.AdvancedEmail = StructNew();

	request.AdvancedEmail.StartTime = GetTickCount();

	// Create array to store cached files in memory
	// If the array exists it might have cached info so don't overwrite
	if (NOT IsDefined("request.AdvancedEmail.CachedFilesArray"))
		request.AdvancedEmail.CachedFilesArray = ArrayNew(1);
			//  1	Reference to location of file on the HD
			//  2	Base64 encoded and wrapped contents of file
			//  3	Original reference to location of file as in the HTML

	// Create array to store other cached variables in memory
	// If the strucure exists it might have cached info so don't overwrite
	if (NOT IsDefined("request.AdvancedEmail.CachedVariables"))
		request.AdvancedEmail.CachedVariables = StructNew();

	// Create array to store information on (inline) attachments
	request.AdvancedEmail.AttachmentArray = ArrayNew(2);
		//  1	String, reference to location of file in HTML/on disk
		//  2	String, name of file without querystring
		//  3	String, CID of this file
		//  4	Boolean, Cache this file
		//  5	String, Base64 encoded and wrapped contents of file
		//  6	String, MIME type
		//  7	Boolean, inline or not 
		//  8	Integer, start of string in the HTML
		//  9	Integer, Length of string in the HTML
		// 10	Integer, Ending position of string in the HTML
		// 11	String, Original reference to location of file as in the HTML

	// Create array to store information on headers
	request.AdvancedEmail.HeaderArray = ArrayNew(2);
		//  1	Headername
		//  2	Headervalue

	request.AdvancedEmail.UnRAttachments = FALSE;
	request.AdvancedEmail.RAttachments = FALSE;
	</cfscript>


<cfelseif ThisTag.ExecutionMode IS 'end'>
	
	<!--- OS based constants: directory separator & linebreak --->
	<cflock scope="SERVER" timeout="2" type="READONLY">
		<cfset variables.OS.Name = Duplicate(Server.OS.Name)>
	</cflock>
	<cfscript>
	// Constants
	if (variables.OS.Name IS "UNIX") {
		CF_CRLF = chr(10);
		DS = "/";
		}
	else {
		CF_CRLF = chr(13) & chr(10);
		DS = "\";
		}
	
	Summary = "<h2>Summary:</h2>#CF_CRLF#<ul>#CF_CRLF#";
	</cfscript>
	
	
	<!--- Get email message body --->
	<cfif IsDefined("request.AdvancedEmail.URL")>
		<cfhttp method="GET" url="#request.AdvancedEmail.URL#" timeout="10" resolveurl="Yes"></cfhttp>
		<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# HTMLText downloaded through CFHTTP.</li>#CF_CRLF#">
		<cfset request.AdvancedEmail.HTMLText = cfhttp.FileContent>
	<!---	<cfset cfhttp.FileContents = ""> --->
		<cfset attributes.inline = TRUE>
	</cfif>
	<cfscript>
	// Get the HTML content of the email message
	if (NOT IsDefined("request.AdvancedEmail.HTMLText"))
		request.AdvancedEmail.HTMLText = thistag.generatedcontent;
	thistag.generatedcontent = "";
	
	if (attributes.type IS NOT "HTML") {
		// Get the Plain Text content of the email message
		if (NOT IsDefined("request.AdvancedEmail.PlainText")) {
			request.AdvancedEmail.PlainText = Request.AdvancedEmail.HTMLText;
			// request.AdvancedEmail.PlainText = REReplaceNoCase(Request.AdvancedEmail.PlainText, "[[:space:]]*<(script)[^>]*>[^<]*</script[^>]*>", "", "ALL");
			// request.AdvancedEmail.PlainText = REReplace(Request.AdvancedEmail.PlainText, "<[^>]+>", "", "ALL");
			request.AdvancedEmail.PlainText = REReplaceNoCase(Request.AdvancedEmail.PlainText, "[[:space:]]*<(script)[^>]*>[^<]*</script[^>]*>|<[^>]+>", "", "ALL");
			request.AdvancedEmail.PlainText = REReplace(Request.AdvancedEmail.PlainText, "[[:space:]]*#chr(13)##chr(10)#[[:space:]]*#chr(13)##chr(10)#", "#chr(13)##chr(10)##chr(13)##chr(10)#", "ALL");
			}
		request.AdvancedEmail.PlainText = Replace(request.AdvancedEmail.PlainText, "#chr(13)##chr(10)#", "#chr(13)##chr(13)##chr(10)#", "ALL");
		}
	request.AdvancedEmail.HTMLText = Replace(request.AdvancedEmail.HTMLText, "#chr(13)##chr(10)#", "#chr(13)##chr(13)##chr(10)#", "ALL");
	</cfscript>
	<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Content parsed</li>#CF_CRLF#">
	
	
	<!--- Attribute validation --->
	
	<!--- From is a required attribute --->
	<cfparam name="attributes.from" type="string">
	<!--- To is a required attribute --->
	<cfparam name="attributes.to" type="string">
	
	<!--- Get spooldir from registry. Spooldir is cached, specify explicitly as an
	attribute of cf_advancedemail if it is supposed to change during a request. --->
	<cfif IsDefined("attributes.spooldir")>
		<cfset request.AdvancedEmail.CachedVariables.spooldir = attributes.spooldir>
	</cfif>
	<cfif NOT IsDefined("request.AdvancedEmail.CachedVariables.spooldir")>
		<cftry>
			<CFREGISTRY
				ACTION="Get"
				ENTRY="BaseDirectory" 
				TYPE="String" 
				BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
				VARIABLE="variables.spooldir"
			>
			<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Spooldir read from registry.</li>#CF_CRLF#">
			<cfset request.AdvancedEmail.CachedVariables.spooldir = variables.spooldir & DS & "spool" & ds>
			<cfcatch type="Any">
				<cfthrow message="Unable to read Spooldir from Registry" detail="CF_ADVANCEDEMAIL tried to read the spooldir from the Registry but failed. The most likely cause of this is that the CFREGISTRY tag has bee disabled. You need to specify the SERVER and SPOOLDIR attributes manually." errorcode="1">
			</cfcatch>
		</cftry>
	</cfif>
	
	<!--- Get server from registry. Server is cached, specify explicitly as an
	attribute of cf_advancedemail if it is supposed to change during a request. --->
	<cfif IsDefined("attributes.server")>
		<cfset request.AdvancedEmail.CachedVariables.server = attributes.server>
	</cfif>
	<cfif NOT IsDefined("request.AdvancedEmail.CachedVariables.server")>
		<cftry>
			<CFREGISTRY
				ACTION="Get"
				ENTRY="Mailserver" 
				TYPE="String" 
				BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
				VARIABLE="variables.server"
			>
			<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Server read from registry.</li>#CF_CRLF#">
			<cfset request.AdvancedEmail.CachedVariables.server = variables.server>
			<cfcatch type="Any">
				<cfthrow message="Unable to read SMTP Server from Registry" detail="CF_ADVANCEDEMAIL tried to read the default mailserver from the Registry but failed. The most likely cause of this is that the CFREGISTRY tag has bee disabled. You need to specify the SERVER and SPOOLDIR attributes manually." errorcode="1">
			</cfcatch>
		</cftry>
	</cfif>
	
	
	<!--- Get port from registry. Port is cached, specify explicitly as an
	attribute of cf_advancedemail if it is supposed to change during a request. --->
	<cfif IsDefined("attributes.port")>
		<cfset request.AdvancedEmail.CachedVariables.port = attributes.port>
	</cfif>
	<cfif NOT IsDefined("request.AdvancedEmail.CachedVariables.port")>
		<cftry>
			<CFREGISTRY
				ACTION="Get"
				ENTRY="SMTPPort" 
				TYPE="String" 
				BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
				VARIABLE="variables.port"
			>
			<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Port read from registry.</li>#CF_CRLF#">
			<cfset request.AdvancedEmail.CachedVariables.port = variables.port>
			<cfcatch type="Any">
				<cfparam name="request.AdvancedEmail.CachedVariables.port" default="25">
			</cfcatch>
		</cftry>
	</cfif>
	
	<!--- Get timeout from registry. Timeout is cached, specify explicitly as an
	attribute of cf_advancedemail if it is supposed to change during a request. --->
	<cfif IsDefined("attributes.timeout")>
		<cfset request.AdvancedEmail.CachedVariables.timeout = attributes.timeout>
	</cfif>
	<cfif NOT IsDefined("request.AdvancedEmail.CachedVariables.timeout")>
		<cftry>
			<CFREGISTRY
				ACTION="Get"
				ENTRY="Timeout" 
				Type="String"
				BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
				VARIABLE="variables.timeout"
			>
			<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Timeout read from registry.</li>#CF_CRLF#">
			<cfset request.AdvancedEmail.CachedVariables.timeout = variables.timeout>
			<cfcatch type="Any">
				<cfparam name="request.AdvancedEmail.CachedVariables.timeout" default="60">
			</cfcatch>
		</cftry>
	</cfif>
	
	<cfif attributes.format IS "xmail">
		<cfset attributes.fromclean = REReplaceNoCase(attributes.from, "^.*<([^>]*)>$", "\1")>
		<cfif NOT IsDefined("request.AdvancedEmail.CachedVariables.PID")>
			<cfset request.AdvancedEmail.CachedVariables.seqnumber = 0>
			<cfset request.AdvancedEmail.CachedVariables.PID = GetTickCount() MOD 3600000>
		</cfif>
	</cfif>
	
	
	<cfscript>
	if (attributes.format IS 'CF')
		CRLF = chr(13)&chr(13)&chr(10);
	else if (attributes.format IS 'xmail')
		CRLF = chr(13)&chr(10);
	else
		CRLF = chr(10);
	
	request.AdvancedEmail.HighASCII = "";
	for (i = 128; i LTE 255; i = i + 1)
		request.AdvancedEmail.HighASCII = request.AdvancedEmail.HighASCII & chr(i);
	
	currentboundary = 0;
	boundary = ArrayNew(1);
	boundary[1] = "----=_NextPart_01_ABCDEF01";
	boundary[2] = "----=_NextPart_02_ABCDEF01";
	boundary[3] = "----=_NextPart_03_ABCDEF01";
	
	// Collect headerinfo into request.AdvancedEmail.HeaderArray
	// Get the correct reply-to
	if (NOT IsDefined("request.AdvancedEmail.Replyto")) {
		TempArray = ArrayNew(1);
		TempArray[1] = 'Reply-to';
		TempArray[2] = attributes.From;
		ArrayPrepend(request.AdvancedEmail.HeaderArray, TempArray);
		}
	
	
	// Get the correct to
	TempArray = ArrayNew(1);
	TempArray[1] = 'To';
	TempArray[2] = attributes.To;
	ArrayPrepend(request.AdvancedEmail.HeaderArray, TempArray);
	
	// Get the correct cc
	if (IsDefined("attributes.CC")) {
		TempArray = ArrayNew(1);
		TempArray[1] = 'CC';
		TempArray[2] = attributes.CC;
		ArrayPrepend(request.AdvancedEmail.HeaderArray, TempArray);
		}
	
	
	// Get the correct subject
	if (NOT IsDefined("request.AdvancedEmail.Subject")) {
		for (variables.CurrentTag = 1 ; variables.CurrentTag LTE ListLen(request.AdvancedEmail.HTMLText, chr(60)) ; variables.CurrentTag = variables.CurrentTag + 1) {
			if (Left(ListGetAt(request.AdvancedEmail.HTMLText, CurrentTag, chr(60)), 5) IS 'title') {
				TempArray = ArrayNew(1);
				TempArray[1] = 'Subject';
				TempArray[2] = REReplaceNoCase(ListRest(ListGetAt(request.AdvancedEmail.HTMLText, CurrentTag, chr(60)), chr(62)),"[#chr(10)##chr(13)#]+"," ","All");
				ArrayPrepend(request.AdvancedEmail.HeaderArray, TempArray);
				break;
				}
			}
		}
	
	
	// Get the correct From
	TempArray = ArrayNew(1);
	TempArray[1] = 'From';
	TempArray[2] = attributes.From;
	ArrayPrepend(request.AdvancedEmail.HeaderArray, TempArray);
	
	
	// Get the correct Date
	Adjustedtime = DateAdd("h", ListFirst(attributes.timezoneoverride), DateAdd("m", ListLast(attributes.timezoneoverride), Now()));
	TimeZoneInfo = GetTimeZoneInfo();
	TimeZoneInfo.utcMinuteOffset = TimeZoneInfo.utcMinuteOffset + ListLast(attributes.timezoneoverride);
	TimeZoneInfo.utcHourOffset = TimeZoneInfo.utcHourOffset + ListFirst(attributes.timezoneoverride);
	
	TimeStamp = DateFormat(AdjustedTime,"ddd, dd mmm yyyy") & TimeFormat(AdjustedTime," HH:mm:ss ") & NumberFormat(-TimeZoneInfo.utcHourOffset,"+09") & NumberFormat(TimeZoneInfo.utcMinuteOffset,"90");
	TempArray = ArrayNew(1);
	TempArray[1] = 'Date';
	TempArray[2] = TimeStamp;
	ArrayPrepend(request.AdvancedEmail.HeaderArray, TempArray);
	
	
	// Get the correct mail software ID string
	TempArray = ArrayNew(1);
	TempArray[1] = 'X-Mailer';
	TempArray[2] = 'cf_advancedemail 2.1 release candidate by Jochem van Dieten';
	ArrayAppend(request.AdvancedEmail.HeaderArray, TempArray);
	
	// Get the correct Mime Version
	TempArray = ArrayNew(1);
	TempArray[1] = 'Mime-version';
	TempArray[2] = '1.0';
	ArrayAppend(request.AdvancedEmail.HeaderArray, TempArray);
	
	// Build array to contain RegEx's for finding images, background images etc.
	request.AdvancedEmail.ExternalFileArray = ArrayNew(1);
		//	1	Description of external file type to be found
		//	2	RegEx to find the external file
		//	3	Number of characters before location of file starts
		//	4	String before location of file starts
		//	5	Number of characters after location of file ends
		//	6	String after location of file ends
		//	7	MIME type (null if not fixed)
	
	TempArray = ArrayNew(1);
	TempArray[1] = 'Everything in a src="" format: images, javascript etc.';
	TempArray[2] = "src=""[^""]+""";
	TempArray[3] = 5;
	TempArray[4] = "src=""";
	TempArray[5] = 1;
	TempArray[6] = """";
	TempArray[7] = "";
	ArrayAppend(request.AdvancedEmail.ExternalFileArray, TempArray);

	ExternalFileArrayPatterns = request.AdvancedEmail.ExternalFileArray[1][2];
	if (ArrayLen(request.AdvancedEmail.ExternalFileArray) GT 1)
		for (i = 2 ; i LTE ArrayLen(request.AdvancedEmail.ExternalFileArray); i = i + 1)
			ExternalFileArrayPatterns = xternalFileArrayPatterns & "|" & request.AdvancedEmail.ExternalFileArray[i][2];

	// Find all occurences of src="...." and dump them in an array
	loop1 = 'Keep running until the search returns 0 hits';
	StartValue = 1;
	while (loop1 IS NOT 1) {
		FindResultsArray = REFindNoCase(ExternalFileArrayPatterns,request.AdvancedEmail.HTMLText,StartValue,"TRUE");
		// Stop loop if no occurences of src="..." are found
		if (FindResultsArray.pos[1] IS 0)
			break;
		TempResult = Mid(request.AdvancedEmail.HTMLText,FindResultsArray.pos[1],FindResultsArray.len[1]);
		for (i = 1 ; i LTE ArrayLen(request.AdvancedEmail.ExternalFileArray); i = i + 1) {
			if (Left(TempResult,request.AdvancedEmail.ExternalFileArray[i][3]) IS request.AdvancedEmail.ExternalFileArray[i][4] AND Right(TempResult,request.AdvancedEmail.ExternalFileArray[i][5]) IS request.AdvancedEmail.ExternalFileArray[i][6])
				if (attributes.inline IS TRUE OR (attributes.inline IS "local" AND Mid(request.AdvancedEmail.HTMLText,FindResultsArray.pos[1] + 5,7) IS NOT "http://")) {
					TempArray = ArrayNew(1);
					TempArray[1] = Mid(TempResult,request.AdvancedEmail.ExternalFileArray[i][3] + 1,Len(TempResult)-request.AdvancedEmail.ExternalFileArray[i][3]-request.AdvancedEmail.ExternalFileArray[i][5]);
					TempArray[2] = ListFirst(GetFileFromPath(TempArray[1]),"?");
					if (ListFind(attributes.Exclude, ListLast(TempArray[2],".")))
						break;
					TempArray[3] = "";
					TempArray[4] = attributes.Cache;
					TempArray[6] = "unknown/unknown";
					TempArray[7] = TRUE;
					TempArray[8] = FindResultsArray.pos[1];
					TempArray[9] = FindResultsArray.len[1];
					TempArray[10] = FindResultsArray.pos[1] + FindResultsArray.len[1];
					TempArray[11] = TempArray[1];
					ArrayAppend(request.AdvancedEmail.AttachmentArray, TempArray);
					request.AdvancedEmail.RAttachments = TRUE;
					}
				break;
			}
		StartValue = FindResultsArray.pos[1] + FindResultsArray.len[1];
		}
	
	// Replace src="path" with src="cid:...." (if appropriate and not redundant)
	for (index = ArrayLen(request.AdvancedEmail.AttachmentArray) ; index GT 0 ; index=index-1) {
		if (request.AdvancedEmail.AttachmentArray[index][7] IS TRUE) {
			for (index2 = ArrayLen(request.AdvancedEmail.AttachmentArray) ; index2 GT index ; index2 = index2 - 1) {
				if (request.AdvancedEmail.AttachmentArray[index][1] IS request.AdvancedEmail.AttachmentArray[index2][1]) {
					request.AdvancedEmail.AttachmentArray[index][3] = request.AdvancedEmail.AttachmentArray[index2][3];
					break;
					}
				}
			if (request.AdvancedEmail.AttachmentArray[index][3] IS "") {
				request.AdvancedEmail.AttachmentArray[index][3] = "920501010@06102000-364" & index;
				request.AdvancedEmail.HTMLText = RemoveChars(request.AdvancedEmail.HTMLText, request.AdvancedEmail.AttachmentArray[index][8] + 5, request.AdvancedEmail.AttachmentArray[index][9] - 6);
				request.AdvancedEmail.HTMLText = Insert("cid:" & request.AdvancedEmail.AttachmentArray[index][3], request.AdvancedEmail.HTMLText, request.AdvancedEmail.AttachmentArray[index][8] + 4);
				}
			else {
				request.AdvancedEmail.HTMLText = RemoveChars(request.AdvancedEmail.HTMLText, request.AdvancedEmail.AttachmentArray[index][8] + 5, request.AdvancedEmail.AttachmentArray[index][9] - 6);
				request.AdvancedEmail.HTMLText = Insert("cid:" & request.AdvancedEmail.AttachmentArray[index][3], request.AdvancedEmail.HTMLText, request.AdvancedEmail.AttachmentArray[index][8] + 4);
				ArrayDeleteAt(request.AdvancedEmail.AttachmentArray, index);
				}
			}
		}
	
	</cfscript>
	
	<!--- Attach encoded images to request.AdvancedEmail.AttachmentArray --->
	<cfloop from="1" to="#ArrayLen(request.AdvancedEmail.AttachmentArray)#" index="CurrentAttachment">
		<cfset FileIsCached = FALSE>
		
		<!--- If possible, use cached version  --->
		<cfif request.AdvancedEmail.AttachmentArray[CurrentAttachment][4] IS TRUE AND StructKeyExists(request.AdvancedEmail, "CachedFilesArray")>
			<cfloop from="1" to="#ArrayLen(request.AdvancedEmail.CachedFilesArray)#" index="CurrentFile">
				<cfif request.AdvancedEmail.CachedFilesArray[CurrentFile][3] IS request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]>
					<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][5] = request.AdvancedEmail.CachedFilesArray[CurrentFile][2]>
					<cfset FileIsCached = TRUE>
					<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# #request.AdvancedEmail.CachedFilesArray[CurrentFile][1]# cache hit.</li>#CF_CRLF#">
					<cfbreak>
				</cfif>
			</cfloop>
		</cfif>
	
		<cfif NOT FileIsCached>
		<!--- We need the uncached version --->
			<cfif Left(request.AdvancedEmail.AttachmentArray[CurrentAttachment][1],7) IS "http://">
				<cfparam name="attributes.TempDir" type="string">
				<cflock name="#Hash(LCase(attributes.TempDir))#" type="EXCLUSIVE" timeout="10">
					<cfhttp method="GET" url="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#" path="#attributes.TempDir#"></cfhttp>
					<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# #request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]# read through CFHTTP.</li>#CF_CRLF#">
					<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] = "unknown/unknown">
					<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][1] = attributes.TempDir & request.AdvancedEmail.AttachmentArray[CurrentAttachment][2]>
					<cffile action="READ" file="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#" variable="temp">
					<cffile action="DELETE" file="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#">
				</cflock>
			<cfelse>
				<cffile action="READ" file="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#" variable="temp">
				<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# #request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]# read from disk.</li>#CF_CRLF#">
			</cfif>
	
			<cfscript>
			temp = ToBase64(temp);
			if (Len(temp) MOD 4 IS "1")
				temp = RemoveChars(temp, Len(temp) - 1, 1);
			CurrentPosition = 72;
			// Base64 encoded stuff has a maximum line length of 1000 characters (but 72 looks nice)
			while (CurrentPosition LTE Len(temp)) {
				temp = Insert(CRLF,temp,CurrentPosition);
				CurrentPosition = CurrentPosition + 72 + Len(CRLF);
				}
			// If caching is enabled write it to the cache.
			if (request.AdvancedEmail.AttachmentArray[CurrentAttachment][4] IS TRUE) {
				TempArray = ArrayNew(1);
				TempArray[1] = request.AdvancedEmail.AttachmentArray[CurrentAttachment][1];
				TempArray[2] = temp;
				TempArray[3] = request.AdvancedEmail.AttachmentArray[CurrentAttachment][11];
				ArrayAppend(request.AdvancedEmail.CachedFilesArray, TempArray);
				}
			request.AdvancedEmail.AttachmentArray[CurrentAttachment][5] = temp;
			request.AdvancedEmail.AttachmentArray[CurrentAttachment][10] = "from <b>HD</b>";
			</cfscript>
		</cfif>
	
		<!--- Set the MIME-type if not set before --->
		<cfif request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] IS "unknown/unknown">
			<cftry>
				<cfregistry action="GET" branch="HKEY_CLASSES_ROOT" entry=".#ListLast(request.AdvancedEmail.AttachmentArray[CurrentAttachment][2],".")#" variable="MIMEType">
				<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] = MIMEType>
				<cfcatch type="Any">
					<cfswitch expression="#ListLast(request.AdvancedEmail.AttachmentArray[CurrentAttachment][2],".")#">
						<cfcase value="gif">
							<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] = "image/gif">
						</cfcase>
						<cfcase value="jpg,jpeg">
							<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] = "image/jpg">
						</cfcase>
						<cfcase value="htm,html,shtml,shtm,shm,cfm,cfml">
							<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] = "text/html">
						</cfcase>
						<cfcase value="vcs">
							<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] = "text/x-vCalendar">
						</cfcase>
						<cfdefaultcase>
						</cfdefaultcase>
					</cfswitch>
				</cfcatch>
			</cftry>
		</cfif>
	
	</cfloop>
	
	<!--- build the entire message --->
	<cfscript>
	// HEADER
	content = "";
	
	if (attributes.Format IS "CF") {
		// The ColdFusion mail header
		content = content & "x-cf-version: " & attributes.cfversion & CF_CRLF;
		content = content & "x-cf-server: "  & request.AdvancedEmail.CachedVariables.server    & CF_CRLF;
		content = content & "x-cf-port: "    & request.AdvancedEmail.CachedVariables.port      & CF_CRLF;
		content = content & "x-cf-timeout: " & request.AdvancedEmail.CachedVariables.timeout   & CF_CRLF;
		content = content & "x-cf-from: "    & attributes.from      & CF_CRLF;
		content = content & "x-cf-to: "      & attributes.to;
		if (IsDefined("attributes.BCC"))
			content = content & ", " & attributes.BCC;
		if (IsDefined("attributes.CC"))
			content = content & ", " & attributes.CC;
		content = content & CF_CRLF;
		content = content & CF_CRLF;
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# ColdFusion envelope.</li>#CF_CRLF#";
		}
	else if (attributes.Format IS "xmail") {
		// The ColdFusion mail header
		content = content & "mail from:<"    & attributes.from  & ">" & CF_CRLF;
		content = content & "rcpt to:<"      & attributes.to    & ">" & CF_CRLF;
		if (IsDefined("attributes.BCC"))
			content = content & "rcpt to:<"  & attributes.BCC   & ">" & CF_CRLF;
		if (IsDefined("attributes.CC"))
			content = content & "rcpt to:<"  & attributes.CC    & ">" & CF_CRLF;
		content = content & "<<MAIL-DATA>>" & CF_CRLF;
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# XMAIL envelope.</li>#CF_CRLF#";
		}
	
	// The normal mail header
	for (index = 1 ; index LTE ArrayLen(request.AdvancedEmail.HeaderArray) ; index = index + 1)
		content = content & request.AdvancedEmail.HeaderArray[index][1] & ": " & request.AdvancedEmail.HeaderArray[index][2] & CRLF;
	Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# SMTP header.</li>#CF_CRLF#";
	
	if (request.AdvancedEmail.UnRAttachments) {
		// multipart/mixed message
		currentboundary = currentboundary + 1;
		content = content & 'Content-Type: multipart/mixed; boundary="' & boundary[currentboundary] & '"' & CRLF;
		content = content & CRLF;
		if (currentboundary IS 1) {
			content = content & 'This is a multi-part message in MIME format.' & CRLF;
			content = content & CRLF;
			}
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# multipart/mixed boundary.</li>#CF_CRLF#";
		}
	
	if (attributes.Type IS 'Alternative') {
		// multipart/alternate message
		if (CurrentBoundary IS NOT 0)
			content = content & '--' & boundary[currentboundary] & CRLF;
		currentboundary = currentboundary + 1;
		content = content & 'Content-Type: multipart/alternative; boundary="' & boundary[currentboundary] & '"' & CRLF;
		content = content & CRLF;
		if (currentboundary IS 1) {
			content = content & 'This is a multi-part message in MIME format.' & CRLF;
			content = content & CRLF;
			}
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# multipart/alternative boundary.</li>#CF_CRLF#";
		}
	
	if (attributes.Type IS NOT 'HTML') {
		// multipart/alternate message
		content = content & '--' & boundary[currentboundary] & CRLF;
		content = content & 'Content-Type: text/plain; charset="iso-8859-1"' & CRLF;
		content = content & 'Content-Transfer-Encoding: 7bit' & CRLF;
		content = content & CRLF;
		content = content & request.AdvancedEmail.PlainText & CRLF;
		content = content & CRLF;
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# text/plain + Content.</li>#CF_CRLF#";
		}
	
	if (request.AdvancedEmail.RAttachments AND attributes.type IS NOT 'text') {
		// multipart/related message
		if (CurrentBoundary IS NOT 0)
			content = content & '--' & boundary[currentboundary] & CRLF;
		currentboundary = currentboundary + 1;
		content = content & 'Content-Type: multipart/related; boundary="' & boundary[currentboundary] & '"' & CRLF;
		content = content & CRLF;
		if (currentboundary IS 1) {
			content = content & 'This is a multi-part message in MIME format.' & CRLF;
			content = content & CRLF;
			}
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# multipart/related boundary.</li>#CF_CRLF#";
		}
	
	if (attributes.type IS NOT 'text') {
		content = content & '--' & boundary[currentboundary] & CRLF;
		content = content & 'Content-Type: text/html; charset="iso-8859-1"' & CRLF;
		content = content & 'Content-Transfer-Encoding: 7bit' & CRLF;
		content = content & CRLF;
		content = content & request.AdvancedEmail.HTMLText & CRLF;
		content = content & CRLF;
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# text/html + content.</li>#CF_CRLF#";
		}
	
	if (request.AdvancedEmail.RAttachments) {
		// Attachments
		for (index = 1 ; index LTE ArrayLen(request.AdvancedEmail.AttachmentArray) ; index = index + 1) {
			if (request.AdvancedEmail.AttachmentArray[index][7]) {
				content = content & '--' & boundary[currentboundary] & CRLF;
				content = content & 'Content-Type: ' & request.AdvancedEmail.AttachmentArray[index][6] & '; name="' & request.AdvancedEmail.AttachmentArray[index][2] & '"' & CRLF;
				content = content & 'Content-Transfer-Encoding: base64' & CRLF;
				content = content & 'Content-ID: <' & request.AdvancedEmail.AttachmentArray[index][3] & '>' & CRLF;
				content = content & CRLF;
				content = content & request.AdvancedEmail.AttachmentArray[index][5] & CRLF;
				content = content & CRLF;
				Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Attached: #request.AdvancedEmail.AttachmentArray[index][2]#</li>#CF_CRLF#";
				}
			}
		}
	
	if (request.AdvancedEmail.RAttachments AND attributes.type IS NOT 'text') {
		// End multipart/related message
		content = content & '--' & boundary[currentboundary] & '--' & CRLF;
		content = content & CRLF;
		currentboundary = currentboundary - 1;
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# multipart/related end boundary.</li>#CF_CRLF#";
		}
	
	if (attributes.Type IS 'Alternative') {
		// End multipart/alternate message
		content = content & '--' & boundary[currentboundary] & '--' & CRLF;
		content = content & CRLF;
		currentboundary = currentboundary - 1;
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# multipart/alternative end boundary.</li>#CF_CRLF#";
		}
	
	if (request.AdvancedEmail.UnRAttachments) {
		// multipart/mixed message
		for (index = 1 ; index LTE ArrayLen(request.AdvancedEmail.AttachmentArray) ; index = index + 1) {
			if (NOT request.AdvancedEmail.AttachmentArray[index][7]) {
				content = content & '--' & boundary[currentboundary] & CRLF;
				content = content & 'Content-Type: ' & request.AdvancedEmail.AttachmentArray[index][6] & '; name="' & request.AdvancedEmail.AttachmentArray[index][2] & '"' & CRLF;
				content = content & 'Content-Transfer-Encoding: base64' & CRLF;
				content = content & 'Content-Disposition: attachment; filename="' & request.AdvancedEmail.AttachmentArray[index][2] & '"' & CRLF;
				content = content & CRLF;
				content = content & request.AdvancedEmail.AttachmentArray[index][5] & CRLF;
				content = content & CRLF;
				Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Attached: #request.AdvancedEmail.AttachmentArray[index][2]#</li>#CF_CRLF#";
				}
			}
	
		// End multipart/mixed message
		content = content & '--' & boundary[currentboundary] & '--' & CRLF;
		content = content & CRLF;
		currentboundary = currentboundary - 1;
		Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# multipart/mixed end boundary.</li>#CF_CRLF#";
		}
			
	</cfscript>
	
	<cfif IsDefined("attributes.variable")>
		<cfset temp = SetVariable("caller." & attributes.variable, content)>
		<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# Content was written to #attributes.variable#.</li>#CF_CRLF#">
	<cfelse>
		<!--- write "content" in a 'single-threaded' way to the spooldir --->
		<cfif attributes.mode IS 'Silent' OR attributes.mode IS 'Debug' OR attributes.mode IS 'DebugShort'>
			<cfif attributes.Format IS "CF">
				<cfset filename = CreateUUID() & ".cfmail">
			<cfelseif attributes.Format IS "xmail">
				<cflock name="AdvancedEmail" timeout="2" type="exclusive">
					<cfset sTime = DateDiff("s",CreateDate(1970, 1, 1), Now())>
					<cfset request.advancedemail.CachedVariables.seqnumber = request.advancedemail.CachedVariables.seqnumber + 1>
					<cfset hostname = ListLast(attributes.fromclean, "@")>
					<cfset filename = stime & "-" & request.advancedemail.CachedVariables.seqnumber & "." & request.AdvancedEmail.CachedVariables.PID & "." & hostname>
				</cflock>
			<cfelse>
				<cfset filename = CreateUUID() & ".msg">
			</cfif>
	
			<cfset writefile = request.advancedemail.CachedVariables.spooldir & filename>

			<cfif NOT FileExists(writefile)>
				<cflock name="#Hash(LCase(writefile))#" type="EXCLUSIVE" timeout="10">
					<cfif NOT FileExists(writefile)>
						<cffile action="WRITE" file="#writefile#" output="#content#" addnewline="No">
						<cfset Summary = summary & "<li>#Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# File was written to #writefile#.</li>#CF_CRLF#">
					</cfif>
				</cflock>
			<cfelse>
				<cfthrow message="Fatal error. File #writefile# already exist.">
			</cfif>
		</cfif>
	</cfif>

	<cfset Summary = summary & "</ul>#CF_CRLF#Time taken: #Evaluate(GetTickCount() - request.AdvancedEmail.StartTime)# ms.#CF_CRLF#">
	
	
	<!--- Cleanup of request.advancedemail and output debugging info --->
	<cfscript>
	// Show debugoutput??
	if (attributes.mode IS 'ViewOnly' OR attributes.mode IS 'Debug' OR attributes.mode IS 'SummaryOnly' OR attributes.mode IS 'DebugShort') {
		thistag.generatedcontent = Summary;
		if (attributes.mode IS NOT 'SummaryOnly' AND attributes.mode IS NOT 'DebugShort')
			thistag.generatedcontent = Summary & "<h2>Message:</h2>" & CRLF & HTMLCodeFormat(content) & CRLF;
		}
	
	// Cleanup of the request scope, except for the BASE64 file cache
	variables.CachedFilesArray = Duplicate(request.AdvancedEmail.CachedFilesArray);
	variables.CachedVariables = Duplicate(request.AdvancedEmail.CachedVariables);
	StructClear(request.AdvancedEmail);
	request.AdvancedEmail.CachedFilesArray = Duplicate(variables.CachedFilesArray);
	request.AdvancedEmail.CachedVariables = Duplicate(variables.CachedVariables);
	variables.CachedFilesArray = "";
	variables.CachedVariables = "";
	</cfscript>

</cfif>
</cfsilent>
	<cfcatch type="Any">
		<cfif cfcatch.errorcode IS NOT 1>
<h2>An error has occured while processing cf_advancedemail</h2>
<p>
<font color="#ff0000">If you have any problems reading this error message, use "View Source".</font>
</p>
<p>
An unexpected error has occured.<br>
Before filing a bug report with me, please make sure that:
<ul>
<li>- you have passed the right attributes to cf_advancedemail</li>
<li>- you have the <a href="http://jochem.vandieten.net/coldfusion/customtags/advancedemail/">latest version</a> of cf_advancedemail</li>
<li>- you are running a supported version of CF (currently 4.5.1 SP2 and 5)</li>
</ul>
If you still think you need to file a bug report, pleas emake sure that:
<ul>
<li>- you send me a <b>plain text</b> email</li>
<li>- you attach the complete error message (with "<a href="http://livedocs.macromedia.com/cf50docs/Installing_and_Configuring_ColdFusion_Server/basiconfig13.jsp">Display the template path in error messages</a>" enabled)</li>
<li>- you attach the calling template</li>
<li>- you attach the file written to the spool folder (if applicable)</li>
<li>- you attach the complete summary below</li>
</ul>
</p>

<cfoutput>#Summary#</cfoutput>

		</cfif>
		<cfrethrow>
	</cfcatch>
</cftry>

