<!------------------------------------------------------------------------------
cf_advancedemailparam
Used in conjunction with cf_advancedemail to send multipart/related emails.

Copyright (c) 2000-2001, Jochem van Dieten
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, 
	  this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, 
	  this list of conditions and the following disclaimer in the documentation 
	  and/or other materials provided with the distribution.
    * Neither the name of the author nor the names of its contributors 
	  may be used to endorse or promote products derived from this software 
	  without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------->
<cfscript>

if (NOT thistag.HasEndTag) {
// This behaviour is exactly the same as CFMAILPARAM
	TempArray = ArrayNew(1);
	if (IsDefined("attributes.File")) {
		TempArray[1] = attributes.File;
		TempArray[2] = GetFileFromPath(TempArray[1]);
		TempArray[3] = "";
		if (IsDefined("attributes.MIME"))
			TempArray[6] = attributes.MIME;
		else
			TempArray[6] = "unknown/unknown";
		TempArray[7] = FALSE;
		if (IsDefined("attributes.Cache") AND attributes.Cache IS FALSE)
			TempArray[4] = FALSE;
		else
			TempArray[4] = TRUE;
		TempArray[11] = attributes.File;
		ArrayAppend(request.AdvancedEmail.AttachmentArray,TempArray);
		request.AdvancedEmail.UnRAttachments = TRUE;
		}
	else {
		if (IsDefined("attributes.Name") AND IsDefined("attributes.Value")) {
			// BCC in cf_advancedemailparam is deprecated
			if (attributes.Name IS 'BCC' or attributes.Name IS 'CC')
				break;
			TempArray[1] = attributes.Name;
			TempArray[2] = attributes.Value;
			ArrayAppend(request.AdvancedEmail.HeaderArray,TempArray);
			if (attributes.Name IS 'Subject')
				request.AdvancedEmail.Subject = TRUE;
			else
				if (attributes.Name IS 'Reply-to')
					request.AdvancedEmail.Replyto = TRUE;
			}
		else {
			StructInsert(request.AdvancedEmail,"URL",attributes.URL,TRUE);
			if (IsDefined("attributes.TempDir") AND NOT IsDefined("request.AdvancedEmail.TempDir"))
				StructInsert(request.AdvancedEmail,"TempDir",attributes.TempDir,TRUE);
			}
		}
	}

else
	if (IsDefined("attributes.ContentType") AND attributes.ContentType IS 'HTML') {
// New options to use HTMLTEXT and Plaintext. End tag required.
		// thistag.GeneratedContent is the HTMLText
		StructInsert(request.AdvancedEmail,"HTMLText",thistag.GeneratedContent,TRUE);
		thistag.GeneratedContent = "";
		}
	else
		if (IsDefined("attributes.ContentType") AND attributes.ContentType IS 'Text') {
			// thistag.GeneratedContent is the PlainText 
			StructInsert(request.AdvancedEmail,"PlainText",thistag.GeneratedContent,TRUE);
			thistag.GeneratedContent = "";
			}
		else {
			// Illegal use
			Error = TRUE;
			thistag.GeneratedContent = "";
			}
</cfscript>

